<?php
 
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Utilities.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Environment.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/sitemap/VariableStack.php" );
 
class StringResolver {
   
   
   
   public static function expandModuleVariable( $inData )
   {
      $inputString = $inData;
      $finished = false;
      $matchPattern = "|([\s\S]+)\{([^\{]+):([\w-]+)\}([\s\S]+)|";
      
      while ( !$finished ) {
         $result = preg_match( $matchPattern, $inputString, $matches, PREG_OFFSET_CAPTURE);
         if ( $result ) {
            $module = $matches[2][0];
            $var = $matches[3][0];
            $module = Environment::$modules[ $module ];
            $replacementString = $module->get( $var );
            $inputString = preg_replace( $matchPattern, $replacementString, $inputString );
         } else {
            $finished = true;
         }
      }
      
      return $inputString;
   }
   
   
   
   public static function expandString( $inVariableStack, $inData )
   {
       $inputString = $inData;
      $finished = false;
      $modulePattern = "|([\s\S]*)\{([^\{]+):([\w-]+)\}([\s\S]*)|";
      $variablePattern = "|([\s\S]*)\{((../)*\d+)\}([\s\S]*)|";
      
      while ( !$finished ) {
         $result = preg_match( $modulePattern, $inputString, $matches, PREG_OFFSET_CAPTURE);
          if ( $result ) {
            $module = $matches[2][0];
            $var = $matches[3][0];
            $module = Environment::$modules[ $module ];
            $replacementString = $module->get( $var );
            $replacementString = "$1$replacementString$4";
            $inputString = preg_replace( $modulePattern, $replacementString, $inputString );
         } else {
            
            $result = preg_match( $variablePattern, $inputString, $matches, PREG_OFFSET_CAPTURE );
            if ( $result ) {
               $replacementString = self::processVar( $inVariableStack, $matches[2][0] );
               $replacementString = $matches[1][0] . $replacementString . $matches[4][0];
               $inputString = preg_replace( $variablePattern, $replacementString, $inputString );
            } else {
               $finished = true;
            }
         }
      }
      
      return $inputString;
   }
    
   
   
   private static function processVar( $inVariableStack, $inVar )
   {
      $p = explode( "/", $inVar );
      
      $level = count( $p ) - 1;
      
      $map = $inVariableStack->entryAt( $level );
      $varIndex = $p[ count( $p ) - 1 ];
      
      
      if ( array_key_exists( $varIndex, $map ) ) {
         return $map[ $varIndex ];
      }
      return "";
   }
   
   
   
   
   public static function expandPseudoProtocols( $inString )
   {
      if ( !is_string( $inString ) ) {
         return $inString;
      }
      $orig = $inString;
      $srcString = "resource://";
      if ( strpos( $inString, $srcString ) !== false ) {
         return str_replace( $srcString, PALOOSE_DIRECTORY . Environment::getPathSeparator(), $inString );
      }
      $srcString = "context://";
      if ( strpos( $inString, $srcString ) !== false ) {
         return str_replace( $srcString, Environment::$configuration[ 'siteRootDirectory' ] . Environment::getPathSeparator(), $inString );
      }
      $srcString = "cocoon://";
      if ( strpos( $inString, $srcString ) !== false ) {
         return str_replace( $srcString, Environment::$gRootSitemapDir . Environment::getPathSeparator(), $inString );
      }
      $srcString = "cocoon:/";
      if ( strpos( $inString, $srcString ) !== false ) {
         return str_replace( $srcString, Environment::$gCurrentSitemapDir . Environment::getPathSeparator(), $inString );
      }
      return $inString;
   }
   
   
   public static function removePseudoProtocols( $inString )
   {
      $srcString = "resource://";
      if ( strpos( $inString, $srcString ) !== false ) {
         return str_replace( $srcString, PALOOSE_DIRECTORY . Environment::getPathSeparator(), $inString );
      }
      $srcString = "context://";
      if ( strpos( $inString, $srcString ) !== false ) {
         return str_replace( $srcString, Environment::getContext(), $inString );
      }
      $srcString = "cocoon://";
      if ( strpos( $inString, $srcString ) !== false ) {
         return str_replace( $srcString, "", $inString );
      }
      $srcString = "cocoon:/";
      if ( strpos( $inString, $srcString ) !== false ) {
         return str_replace( $srcString, "", $inString );
      }
      return $inString;
   }
}
?>
