<?php
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Utilities.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Environment.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/resources/Resource.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/flows/Script.php" );
class Flow {
   
   private $gScripts;
   
   private $gLanguage;
      
   
   
   
   public function __construct()
   {
      $this->gScripts = array();
   }
   
   
   
   public function parse( DOMNode $inNode )
   {
      
      $scriptsDom = new DOMDocument;
      $scriptsDom->appendChild( $scriptsDom->importNode( $inNode, 1 ) );
      
      
      $xpath = new domxpath( $scriptsDom );
      $xpath->registerNamespace( "m", Environment::$configuration[ 'sitemapNamespace' ] );
      $this->gLanguage = Utilities::getXPathListStringItem( 0, $xpath, "//@language" );
      if ( !isset( $this->gLanguage ) ) {
         $dom = new DOMDocument;
         $dom->appendChild( $dom->importNode( $inNode, 1 ) );
         throw new UserException( "Must be associated language attribute with flow", PalooseException::SITEMAP_FLOW_PARSE_ERROR, $dom );
      }
      $scriptNodes = $xpath->query( "//m:script" );
      
      $idx = 0;
      foreach ( $scriptNodes as $node ) { 
         try {
            $script = new Script();
            $script->parse( $node );
            $this->gScripts[ $idx++ ] = $script;
         } catch ( UserException $e ) {
            throw new UserException( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
         }
      }
   }
   
   
   
    
   public function getScript( $inName )
   {
      return $this->gScripts[ $inName ];
   }
   
   
   
    
   public function toString()
   {
      $mess = "";
      if ( $this->gScripts != null ) {
         $mess = "  <flow>\n";
         foreach ( $this->gScripts as $name => $script ) {
            $mess .= $script->toString();
         }
         $mess .= "  </flow>\n";
      }
      return $mess;
   }
}
?>
