<?php
require_once( PALOOSE_LIB_DIRECTORY . "/exception-handling/MatcherException.php" );
class WildcardURIMatcher {
    
    
    const MATCH_FILE = -1;
    const MATCH_FILE_REGEXP = "([^\/]*)";
    
    
    const MATCH_PATH = -2;
    const MATCH_PATH_REGEXP = "(.*)";
    
    
    const MATCH_BEGIN = -4;
    const MATCH_BEGIN_REGEXP = "/^";
    
    
    const MATCH_THEEND = -5;
    const MATCH_THEEND_REGEXP = "\$/";
    
    
    const MATCH_END = -3;
    const MATCH_END_REGEXP = "\$/";
    
    private $gHashMap;
    
    
    
    
    
    
    
    public function __construct()
    {
        $this->gHashMap = array();
    }
    
    
    
    
    
    private function compilePattern( $inData )
    {
        $expr = "";
        unset( $expr );
        $buff = $this->toCharArray( $inData );
        
        
        $y = 0;
        $slash = false;
        
        
        $expr[ $y++ ] = self::MATCH_BEGIN;
        
        if ( !empty( $buff ) ) {
            if ( $buff[ 0 ]=='\\' ) {
                $slash = true;
            } else if ( $buff[ 0 ] == '*' ) {
                $expr[ $y++ ] = self::MATCH_FILE;
            }  else {
                $expr[ $y++ ] = $buff[ 0 ];
            }
            
            
            for ( $x = 1; $x < count( $buff ); $x++ ) {
                
                if ( $slash ) {
                    $expr[ $y++ ] = $buff[ $x ];
                    $slash = false;
                    
                } else {
                    
                    if ( $buff[ $x ] == '\\' ) {
                        $slash = true;
                        
                    } else if ( $buff[ $x ] == '*' ) {
                        
                        if ( $expr[ $y-1 ] <= self::MATCH_FILE ) {
                            $expr[ $y-1 ] = self::MATCH_PATH;
                        } else {
                            $expr[ $y++ ] = self::MATCH_FILE;
                        }
                    } else {
                        $expr[ $y++ ]=$buff[ $x ];
                    }
                }
            }
        }
        
        $expr[ $y ] = self::MATCH_THEEND;
        return $expr;
    }
    
    
    
    
    
    public function pattern2regexp( $inPattern, $inPatternString )
    {
        
        $regexp = "";
        
        for ( $i = 0; $i < count( $inPattern ); $i++ ) {
            $chr = $inPattern[ $i ];
            
            switch ( $chr ) {
                    
                case self::MATCH_BEGIN :
                    $regexp .= self::MATCH_BEGIN_REGEXP;
                    $inText = false;
                    break;
                    
                case self::MATCH_PATH :
                    
                    $regexp .= self::MATCH_PATH_REGEXP;
                    break;
                    
                case self::MATCH_FILE:
                    $regexp .= self::MATCH_FILE_REGEXP;
                    break;
                    
                case self::MATCH_THEEND :
                    $regexp .= self::MATCH_THEEND_REGEXP;
                    break;
                    
                case "$" :
                    $regexp .= "\\\$";
                    break;
                    
                case "^" :
                    $regexp .= "\^";
                    break;
                    
                case "/" :
                    $regexp .= "\/";
                    break;
                    
                case "." :
                    
                    $regexp .= "\.";
                    break;
                    
                default :
                    $regexp .= $chr;
                    
            }
            
        }
        
        return $regexp;
        
    }
    
    
    
    
    
    public function match( $inData, $inPattern )
    {
        $globalsModule = Environment::$modules[ 'global' ];
        
        $preparedPattern = $this->compilePattern( $inPattern );
        
        $regExprPattern = $this->pattern2regexp( $preparedPattern, $inPattern );
        
        $this->gHashMap = array();
        $m = preg_match( $regExprPattern, $inData, $this->gHashMap );
        
        
        $i = 0;
        foreach( $this->gHashMap as $value ) {
            $globalsModule->add( "__$i", $value );
            $i++;
        }
        return $m;
    }
    
    
    
    
    
    public function getHashMap()
    {
        return $this->gHashMap;
    }
    
    
    
    
    
    function  toCharArray( $inString )
    {
        $len = strlen( $inString );
        for ( $j = 0; $j < strlen ( $inString ); $j++ ) {
            $char[ $j ]  =  substr( $inString,  $j,  1 );
        }
        return $char;
    }
    
    
    
    
    
    public function toString( )
    {
        $mess = "<matcher name='{$this->gType}' src='{$this->gSrc}' package='{$this->classname( )}'/>\n";
        return $mess;
    }
    
}
?>
