<?php
require_once( PALOOSE_LIB_DIRECTORY . "/exception-handling/InternalException.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/exception-handling/UserException.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/exception-handling/RunException.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/exception-handling/ExitException.php" );
class Pipe {
   
   private $gPipeComponentList;
   
   private $gPipeComponentListIndex;
  
      
   
   
   public function __construct()
   {
      $this->gPipeComponentListIndex = 0;
   }
   
   
   public function addComponent( $inNode )
   {
      $this->gPipeComponentList[ $this->gPipeComponentListIndex ] = $inNode;
      $this->gPipeComponentListIndex++;
   } 
   
   
   
    
   public function run( $inVariableStack, $inURL, $inQueryString, $inLabelDOM )
   {
      $requestParams = Environment::$modules[ "request-param" ];
      $label = $requestParams->get( "paloose-view" );
      
      $fromLabel = false;
      $fromPosition = false;
      if ( !empty( $label ) ) {
         $views = Environment::$sitemapStack->peek()->getViews();
         $view = $views->getView( $label );
         if ( $view != NULL ) {
            $fromLabel = $view->getFromLabel();
            $fromPosition = $view->getFromPosition();
         }
      }
      
      
      $firstStage = $this->gPipeComponentList[ 0 ];
      
      
      $documentDOM = $inLabelDOM;
      $finished = false;
      if ( $documentDOM != NULL or
            $firstStage->getGenericType() == PipeElement::REDIRECT or
            $firstStage->getGenericType() == PipeElement::MOUNT or
            $firstStage->getGenericType() == PipeElement::READER or
            $firstStage->getGenericType() == PipeElement::GENERATOR or
            $firstStage->getGenericType() == PipeElement::CALL or
            $firstStage->getGenericType() == PipeElement::ACTION or
            $firstStage->getGenericType() == PipeElement::SELECTOR or
            $firstStage->getGenericType() == PipeElement::AGGREGATOR ) {
         
         for ( $i = 0; $i < count( $this->gPipeComponentList ) and $finished !== true; $i++ ) {
            $component = $this->gPipeComponentList[ $i ];
            switch ( $component->getGenericType() ) {
               case PipeElement::REDIRECT :
                  try {
                     $component->run( $inVariableStack, $inURL, $inQueryString, new DomDocument() );
                  } catch ( ExitException $e ) {
                     throw new ExitException();
                  } catch ( UserException $e ) {
                     throw new UserException( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
                  } catch ( RunException $e ) {
                     throw new RunException( $e->getMessage(), $e->getCode() );
                  }
                  break;
              case PipeElement::MOUNT :
                  try {
                     $component->run( $inVariableStack, $inURL, $inQueryString, new DomDocument() );
                  } catch ( ExitException $e ) {
                     throw new ExitException();
                  } catch ( UserException $e ) {
                     throw new UserException( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
                  } catch ( RunException $e ) {
                     throw new RunException( $e->getMessage(), $e->getCode() );
                  }
                  break;
               case PipeElement::AGGREGATOR :
                  try {
                     $documentDOM = $component->run( $inVariableStack, $inURL, $inQueryString, new DomDocument() );
                     
                     
                     $componentLabel = $component->getLabel();
                     if ( $fromLabel !== false and $fromLabel == $componentLabel ) {
                        
                        $views = Environment::$sitemapStack->peek()->getViews();
                        $view = $views->getView( $label );
                        $pipe = $view->getPipe();
                        
                        $outputStream = new OutputStream( OutputStream::STANDARD_OUTPUT );
                        Environment::$sitemapStack->peek()->setOutputStream( $outputStream );
                        $pipe->run( $inVariableStack, $inURL, $inQueryString, $documentDOM );
                        
                        throw new ExitException();
                     }
                  } catch ( ExitException $e ) {
                     throw new ExitException();
                  } catch ( UserException $e ) {
                     throw new UserException( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
                  } catch ( RunException $e ) {
                     throw new RunException( $e->getMessage(), $e->getCode() );
                  }
                  break;
               case PipeElement::GENERATOR :
                  try {
                     $documentDOM = $component->run( $inVariableStack, $inURL, $inQueryString, new DomDocument() );
                     
                     
                     $componentLabel = $component->getLabel();
                     if ( $fromLabel !== false and $fromLabel == $componentLabel ) {
                        
                        $views = Environment::$sitemapStack->peek()->getViews();
                        $view = $views->getView( $label );
                        $pipe = $view->getPipe();
                        
                        $outputStream = new OutputStream( OutputStream::STANDARD_OUTPUT );
                        Environment::$sitemapStack->peek()->setOutputStream( $outputStream );
                        $pipe->run( $inVariableStack, $inURL, $inQueryString, $documentDOM );
                        
                        throw new ExitException();
                     }
                  } catch ( ExitException $e ) {
                     throw new ExitException();
                  } catch ( UserException $e ) {
                     throw new UserException( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
                  } catch ( RunException $e ) {
                     throw new RunException( $e->getMessage(), $e->getCode() );
                  }
                  break;
               case PipeElement::SELECTOR :
                  try {
                     
                     
                     
                     if ( $documentDOM == NULL ) {
                        $documentDOM = new DomDocument();
                     }
                     $documentDOM = $component->run( $inVariableStack, $inURL, $inQueryString, $documentDOM );
                     
                     
                     $componentLabel = $component->getLabel();
                     if ( $fromLabel !== false and $fromLabel == $componentLabel ) {
                        
                        $views = Environment::$sitemapStack->peek()->getViews();
                        $view = $views->getView( $label );
                        $pipe = $view->getPipe();
                        
                        $outputStream = new OutputStream( OutputStream::STANDARD_OUTPUT );
                        Environment::$sitemapStack->peek()->setOutputStream( $outputStream );
                        $pipe->run( $inVariableStack, $inURL, $inQueryString, $documentDOM );
                        
                        throw new ExitException();
                     }
                  } catch ( ExitException $e ) {
                     
                     
                     throw new ExitException();
                  } catch ( UserException $e ) {
                     throw new UserException( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
                  } catch ( RunException $e ) {
                     throw new RunException( $e->getMessage(), $e->getCode() );
                  }
                  break;
               case PipeElement::TRANSFORMER :
                  try {
                     $documentDOM = $component->run( $inVariableStack, $inURL, $inQueryString, $documentDOM );
                     
                     
                     $componentLabel = $component->getLabel();
                     if ( $fromLabel !== false and $fromLabel == $componentLabel ) {
                        
                        $views = Environment::$sitemapStack->peek()->getViews();
                        $view = $views->getView( $label );
                        $pipe = $view->getPipe();
                        
                        $outputStream = new OutputStream( OutputStream::STANDARD_OUTPUT );
                        Environment::$sitemapStack->peek()->setOutputStream( $outputStream );
                        $pipe->run( $inVariableStack, $inURL, $inQueryString, $documentDOM );
                        
                        throw new ExitException();
                     }
                  } catch ( ExitException $e ) {
                     throw new ExitException();
                  } catch ( UserException $e ) {
                     throw new UserException( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
                  } catch ( RunException $e ) {
                     throw new RunException( $e->getMessage(), $e->getCode() );
                  }
                  break;
               case PipeElement::SERIALIZER :
                  try {
                     $component->run( $inVariableStack, $inURL, $inQueryString, $documentDOM );
                  } catch ( ExitException $e ) {
                     throw new ExitException();
                  } catch ( UserException $e ) {
                     throw new UserException( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
                  } catch ( RunException $e ) {
                     throw new RunException( $e->getMessage(), $e->getCode() );
                  }
                  break;
                  
               case PipeElement::READER :
                 try {
                     $documentDOM = $component->run( $inVariableStack, $inURL, $inQueryString, new DomDocument() );
                   } catch ( ExitException $e ) {
                     throw new ExitException();
                  } catch ( UserException $e ) {
                     throw new UserException( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
                  } catch ( RunException $e ) {
                     throw new RunException( $e->getMessage(), $e->getCode() );
                  }
                  break;
                  
              case PipeElement::CALL :
                  try {
                     $component->run( $inVariableStack, $inURL, $inQueryString, ( $documentDOM == NULL ? new DOMDocument : $documentDOM ) );
                  } catch ( ExitException $e ) {
                     throw new ExitException();
                  } catch ( UserException $e ) {
                     throw new UserException( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
                  } catch ( RunException $e ) {
                     throw new RunException( $e->getMessage(), $e->getCode() );
                  }
                  break;
              case PipeElement::ACTION :
                 
                 if ( $documentDOM == NULL ) $documentDOM = new DOMDocument();
                  try {
                     $component->run( $inVariableStack, $inURL, $inQueryString, $documentDOM );
                  } catch ( ExitException $e ) {
                     throw new ExitException();
                  } catch ( UserException $e ) {
                     throw new UserException( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
                  } catch ( RunException $e ) {
                     throw new RunException( $e->getMessage(), $e->getCode() );
                  }
                  break;
             }
         }
         return $documentDOM;
      } else {
         $this->msg = "First pipe element must be a generator, but found component type " . $firstStage->getGenericTypeName();
         throw new RunException( $this->msg, PalooseException::SITEMAP_PIPE_ERROR );
      }
   }
  
   
   public function toString()
   {
      $size = $this->getComponentListSize();
      $mess = "";
      if ( $size > 0 ) {
         for ( $i = 0; $i < $size; $i++ ) {
            $node = $this->gPipeComponentList[ $i ];
            $mess .= $node->toString();
         }
      }
      return $mess;
   } 
   
   
   public function getComponentListSize()
   {
      return $this->gPipeComponentListIndex;
   } 
   
   
   public function isValid()
   {
   } 
}
?>
