<?php
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Environment.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Browser.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/pipelines/PipeElement.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/pipelines/PipeElementInterface.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/selection/Selector.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/selection/SelectorPipeElement.php" );
class BrowserSelector extends SelectorPipeElement implements PipeElementInterface
{
    
    
   
   
    
   public function __construct( DOMDocument $inDOM, $inType = "", $inSrc = "", $inComponent = NULL )
   {
      parent::__construct( $inDOM, $inType, $inSrc, $inComponent );
   }
   
   
   
   public function run( VariableStack $inVariableStack, $inURL, $inQueryString, DOMDocument $inDOM )
   {
      
      $browser = new Browser();
      
      
      
   
      $testFound = false;
      $userAgents = $this->gComponent->getUserAgents();
      $idx = -1;
        foreach ( $this->gWhenPipes as $name => $pipe ) {
            $idx = $this->gComponent->getNameIndex( $name );
            if ( $idx > -1 ) {
                
                $userAgent = $userAgents[ $idx ];
                if ( $browser->getName() == $userAgent ) {
                   $testFound = true;
                   break;
                }
            } else {
                
                break;
            }
        }
      
      if ( $testFound === true ) {
         $pipe = $this->gWhenPipes[ $name ];
         $documentDOM = $pipe->run( Environment::$variableStack, $inURL, $inQueryString, $inDOM );
      } else {
         if ( $this->gOtherwisePipe->getComponentListSize() > 0 ) {
            $documentDOM = $this->gOtherwisePipe->run( Environment::$variableStack, $inURL, $inQueryString, $inDOM );
         } else {
            return $inDOM;
         }
      }
      return $documentDOM;
   }
}
 
class _BrowserSelector extends Selector {
    
   
   
   private $gBrowserName;
   
   
   private $gBrowserAgent;
   
   
   
   
   public function __construct( $inName, $inSrc, DOMNode $inParameterNode, $inIsCachable )
   {
      parent::__construct( $inName, $inSrc, $inParameterNode, $inIsCachable );
      $this->gPackageName = "BrowserSelector";
      
        
      $browserDOM = new DOMDocument;
      $browserDOM->appendChild( $browserDOM->importNode( $inParameterNode, 1 ) );
        
      $xpath = new domxpath( $browserDOM );
      $xpath->registerNamespace( "m", Environment::$configuration[ 'sitemapNamespace' ] );
      $component = $xpath->query( "//m:selector/*" );
      
      
      $idx = 0;
      foreach ( $component as $node ) {
         if ( $node->localName == "browser" ) {
            $name = $node->getAttribute( "name" );
            $userAgent = $node->getAttribute( "useragent" );
            $this->gBrowserName[ $idx ] = $name;
            $this->gBrowserAgent[ $idx ] = $userAgent;
            $idx++;
         }
      }
   }
   
   
   
    
   public function isValid()
   {
      $parentIsValid = parent::isValid();
      
      return $parentIsValid;
   } 
   
   
   
    
   public function getBrowserName()
   {
      return $this->gBrowserName;
   } 
   
   
   
    
   public function getNameIndex( $inName )
   {
      $idx = 0;
      foreach ( $this->gBrowserName as $name ) {
         if ( strcmp( $name, $inName ) == 0 ) return $idx;
         $idx++;
      }
      return -1;
   } 
   
   
   
    
   public function getUserAgents()
   {
      return $this->gBrowserAgent;
   } 
   
   
   
    
   public function toString()
   {
      if ( $this->gParameters == NULL && $this->gBrowserAgent == NULL ) {
         return "   <selector name='{$this->gType}' src='{$this->gSrc}' package='{$this->gPackageName}'/>\n";
      }
      $mess = "   <selector name='{$this->gType}' src='{$this->gSrc}' package='{$this->gPackageName}'>\n";
      if ( $this->gParameters != NULL ) {
         while ( list( $name, $value ) = each( $this->gParameters ) ) {
            $mess .= "    <parameter name='$name' value='$value'/>\n";
         }
         reset( $this->gParameters );
      }
      if ( $this->gBrowserAgent != NULL ) {
         while ( list( $idx, $value ) = each( $this->gBrowserAgent ) ) {
            $mess .= "    <browser name='" . $this->gBrowserName[ $idx ] . "' useragent='$value'/>\n";
         }
         reset( $this->gBrowserAgent );
      }
      $mess .= "   </selector>\n";
      return $mess;
   }
}
?>
