<?php
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Environment.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Browser.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/pipelines/PipeElement.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/pipelines/PipeElementInterface.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/selection/Selector.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/selection/SelectorPipeElement.php" );
class MobileSelector extends SelectorPipeElement implements PipeElementInterface
{
   
   
   
   
    
   public function __construct( DOMDocument $inDOM, $inType = "", $inSrc = "", $inComponent = NULL )
   {
      parent::__construct( $inDOM, $inType, $inSrc, $inComponent );
   }
   
   
   
   public function run( VariableStack $inVariableStack, $inURL, $inQueryString, DOMDocument $inDOM )
   {
      
      $browser = new Browser();
            
      if ( $browser->isMobile() === true ) {
         
         $pipe = $this->gWhenPipes[ "mobile" ];
         $documentDOM = $pipe->run( Environment::$variableStack, $inURL, $inQueryString, $inDOM );
      } else {
         if ( $this->gOtherwisePipe->getComponentListSize() > 0 ) {
            $documentDOM = $this->gOtherwisePipe->run( Environment::$variableStack, $inURL, $inQueryString, $inDOM );
         } else {
            return $inDOM;
         }
      }
      return $documentDOM;
   }
}
 
class _MobileSelector extends Selector {
    
   
   
   
   
   public function __construct( $inName, $inSrc, DOMNode $inParameterNode, $inIsCachable )
   {
      parent::__construct( $inName, $inSrc, $inParameterNode, $inIsCachable );
      $this->gPackageName = "MobileSelector";
      
        
      $browserDOM = new DOMDocument;
      $browserDOM->appendChild( $browserDOM->importNode( $inParameterNode, 1 ) );
        
      $xpath = new domxpath( $browserDOM );
      $xpath->registerNamespace( "m", Environment::$configuration[ 'sitemapNamespace' ] );
      $component = $xpath->query( "//m:selector/*" );
      
      
      $idx = 0;
      foreach ( $component as $node ) {
         if ( $node->localName == "browser" ) {
            $name = $node->getAttribute( "name" );
            $userAgent = $node->getAttribute( "useragent" );
            $this->gBrowserName[ $idx ] = $name;
            $this->gBrowserAgent[ $idx ] = $userAgent;
            $idx++;
         }
      }
   }
   
   
   
    
   public function isValid()
   {
      $parentIsValid = parent::isValid();
      
      return $parentIsValid;
   } 
   
   
   
    
   public function getUserAgents()
   {
      return $this->gBrowserAgent;
   } 
   
   
   
    
   public function toString()
   {
       return "   <selector name='{$this->gType}' src='{$this->gSrc}' package='{$this->gPackageName}'/>\n";
   }
}
?>
