<?php
require_once( PALOOSE_LIB_DIRECTORY . "/sitemap/Component.php" );
class Serializer extends Component {
   
   
   
   
   public $gEncoding;
   
   
   public $gPublicDoctype;
   
   
   public $gSystemDoctype;
   
   
   public $gOmitXMLDeclaration;
   
   
   public $gCdataEncode = "";
   
   
   
   
   
   public function __construct( $inName, $inClassName, DOMNode $inParameterNode, $inIsCachable )
   {
      parent::__construct( $inName, $inClassName, $inParameterNode, $inIsCachable );
      $this->gGenericType = PipeElement::SERIALIZER;
      $this->gType = "serializer";
      
      $parameterDOM = new DOMDocument;
      $parameterDOM->appendChild( $parameterDOM->importNode( $inParameterNode, 1 ) );
      
      $xpath = new domxpath( $parameterDOM );
      $xpath->registerNamespace( "m", Environment::$configuration[ 'sitemapNamespace' ] );
      
      $this->gSystemDoctype = Utilities::getXPathListStringItem( 0, $xpath, "//*[local-name()='property' and @name = 'doctype-system']/@value" );
      
      $this->gPublicDoctype = Utilities::getXPathListStringItem( 0, $xpath, "//*[local-name()='property' and @name = 'doctype-public']/@value" );
      
      $omitEncoding = Utilities::getXPathListStringItem( 0, $xpath, "//*[local-name()='property' and @name = 'omit-xml-declaration']/@value" );
      $this->gOmitXMLDeclaration = false;
      if ( strlen( $omitEncoding ) > 0 && $omitEncoding == "yes" ) {
         $this->gOmitXMLDeclaration = true;
      }
      
      $this->gEncoding = Utilities::getXPathListStringItem( 0, $xpath, "//*[local-name()='property' and @name = 'encoding']/@value" );
      if ( strlen( $this->gEncoding ) == 0 ) {
         $this->gEncoding = "UTF-8";
      }
      
      $this->gCdataEncode = Utilities::getXPathListStringItem( 0, $xpath, "//*[local-name()='property' and @name = 'cdata-encode']/@value" );
      
   }
   
   
   
   
   public function isValid()
   {
      try {
         parent::isValid();
      } catch ( UserException $e ) {
         throw new UserException( "Serializer: " . $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
      }
   }
   
   
   
   
   public function toString()
   {
      if ( $this->gParameters != NULL ) {
         $mess = "   <serializer name='{$this->gName}' src='{$this->gSrc}' package='{$this->gPackageName}'>\n";
         while ( list( $name, $value ) = each( $this->gParameters ) ) {
            $mess .= "    <parameter name='$name' value='$value'/>\n";
         }
         reset( $this->gParameters ); 
         $mess .= "   </serializer>\n";
      } else {
         $mess = "   <serializer name='{$this->gName}' src='{$this->gSrc}' package='{$this->gPackageName}'/>\n";
      }
      return $mess;
   }
   
}
?>
