<?php
 
#[AllowDynamicProperties]
class Component {
   
   protected $gType;
   
      
   protected $gName;
   
   
   protected $gPackageName;
   
   
   
   protected $gParameterDOM;
   
   
   protected $gParameters;
   
   protected $gUseRequestParameters;
   
   
   public $gIsCachable;
      
   
   
   
   public function __construct( $inName, $inSrc, DOMNode $inNode, $inIsCachable )
   {
       
      $this->gSrc = $inSrc;
      $this->gName = $inName;
      $this->gIsCachable = $inIsCachable;
      $this->gPackageName = $inSrc;      
      $this->gParameters = array();
      $this->gUseRequestParameters = false;
      
      $this->gParameterDOM = new DOMDocument;
      $this->gParameterDOM->appendChild( $this->gParameterDOM->importNode( $inNode, 1 ) );
        
      $xpath = new domxpath( $this->gParameterDOM );
      $xpath->registerNamespace( "m", Environment::$configuration[ 'sitemapNamespace' ] );
      $component = $xpath->query( "//*" );
      foreach ( $component as $node ) {
         if ( $node->localName == "parameter" ) {
            $name = $node->getAttribute( "name" );
            $value = $node->getAttribute( "value" );
            $this->gParameters[ $name ] = $value;
         } else if ( $node->localName == "use-request-parameters" ) {
            $this->setUseRequestParametersFlag( Utilities::normalizeBoolean( $node->textContent ) );
         }
      }
   }
   
   
   
   
   public function getName()
   {
      return $this->gName;
   } 
   
   
   
   public function getParameterDOM()
   {
      return $this->gParameterDOM;
   } 
   
   
   
   public function getParameters()
   {
      return $this->gParameters;
   } 
   
   
   
   public function getType()
   {
      return $this->gType;
   } 
   
   
   
   public function setPackageFileName( $inName )
   {
      $this->gPackageName = $inName;
   } 
   
   
   
    
   public function getPackageName()
   {
      return $this->gPackageName;
   } 
   
   
   
   public function setUseRequestParametersFlag( $inFlag )
   {
      $this->gUseRequestParameters = $inFlag;
   } 
   
   
   
   public function getUseRequestParametersFlag()
   {
      if ( $this->gUseRequestParameters == NULL ) return false;
      return $this->gUseRequestParameters;
   } 
   
   
   
   public function isValid()
   {
      if ( !( strlen( $this->gName ) > 0 and strlen( $this->gPackageName ) > 0 ) ) {
         throw new UserException(
            "Component must have a name and package",
            PalooseException::SITEMAP_GENERATOR_PARSE_ERROR,
            $this->gParameterDOM );
      }
   } 
   
   
   
   public function toString()
   {
   }
}
?>
