<?php
 
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Environment.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/pipelines/PipeElement.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/pipelines/PipeElementInterface.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/sitemap/Parameter.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/authentication/EncryptBF.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/transforming/TransformerPipeElement.php" );
 
class BlowfishVerifyTransformer extends TransformerPipeElement implements PipeElementInterface
{
      
   
   
   
   public function __construct( DOMDocument $inDOM, $inType = "", $inSrc = "", $inComponent = NULL )
   {
       try {
          parent::__construct( $inDOM, $inType, $inSrc, $inComponent );
       } catch ( UserException $e ) {
          throw new UserException( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
       }
   }
   
   
   
   public function run( VariableStack $inVariableStack, $inURL, $inQueryString, DOMDocument $inDOM )
   {
      $documentDOM = $inDOM;
      $rootNode = $documentDOM->documentElement;
      
      $this->gTranslatedDOM = new DOMDocument();
      $elementNS = $rootNode->namespaceURI;
      $newElement = $this->gTranslatedDOM->createElementNS( $elementNS, $rootNode->nodeName );
      $username = "";
      $password = "";
      $encryptedPassword = "";
      $xpath = new DOMXpath( $inDOM );
      $nodes = $xpath->query( "/authentication/@username" );
      if ( !is_null( $nodes ) ) {
         $username = $nodes[0]->textContent;
      }
      
      $nodes = $xpath->query( "/authentication/@password" );
      if ( !is_null( $nodes ) ) {
         $password = $nodes[0]->textContent;
      }
      
      $nodes = $xpath->query( "//password" );
      if ( !is_null( $nodes ) ) {
         $encryptedPassword = $nodes[0]->textContent;
      }
      
      
      
      $emptyPassword = ( strlen($password) == 0 and $encryptedPassword == 0 );
      if ( EncryptBF::verify( $username, $password, $encryptedPassword ) or $emptyPassword ) {
         $xmlString = "<authentication verify='true'>
   <users>
      <user>
         <username>$username</username>
         <password>$encryptedPassword</password>
      </user>
   </users>
</authentication>";
      } else {
         $xmlString = "<authentication verify='false'/>";
      }
      $this->gTranslatedDOM = new DOMDocument();
      $this->gTranslatedDOM->loadXML( $xmlString );
   
      return $this->gTranslatedDOM;
   }
   
   
   
  
   public function toString()
   {
      return parent::toStringWithType( $this->gGenericType );
   }
}
 
class _BlowfishVerifyTransformer extends Transformer {
    
   
   
   
   
   public function __construct( $inName, $inSrc, DOMNode $inParameterNode, $inIsCachable )
   {
      parent::__construct( $inName, $inSrc, $inParameterNode, $inIsCachable );
      $this->gPackageName = "BlowfishVerifyTransformer";
   }
}
?>
